--Copyright 1986-2016 Xilinx, Inc. All Rights Reserved.
----------------------------------------------------------------------------------
--Tool Version: Vivado v.2016.2 (win64) Build 1577090 Thu Jun  2 16:32:40 MDT 2016
--Date        : Tue Jan 17 12:47:59 2017
--Host        : W8-64-02 running 64-bit major release  (build 9200)
--Command     : generate_target ibert_top.bd
--Design      : ibert_top
--Purpose     : IP block netlist
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
entity ibert_top is
  generic (
    -- IBERT start:
    C_NUM_QUADS : integer :=1;
    C_REFCLKS_USED : integer :=1
    -- IBERT finished:
  );
  port (
    -- IBERT start:
    TXN_O : out STD_LOGIC_VECTOR((4*C_NUM_QUADS)-1 downto 0);
    TXP_O : out STD_LOGIC_VECTOR((4*C_NUM_QUADS)-1 downto 0);
    RXN_I : in STD_LOGIC_VECTOR((4*C_NUM_QUADS)-1 downto 0);
    RXP_I : in STD_LOGIC_VECTOR((4*C_NUM_QUADS)-1 downto 0);
    GTREFCLK0P_I : in STD_LOGIC_VECTOR(C_REFCLKS_USED-1 downto 0);
    GTREFCLK0N_I : in STD_LOGIC_VECTOR(C_REFCLKS_USED-1 downto 0);
    GTREFCLK1P_I : in STD_LOGIC_VECTOR(C_REFCLKS_USED-1 downto 0);
    GTREFCLK1N_I : in STD_LOGIC_VECTOR(C_REFCLKS_USED-1 downto 0);
    -- IBERT finished:
    DDR_addr : inout STD_LOGIC_VECTOR ( 14 downto 0 );
    DDR_ba : inout STD_LOGIC_VECTOR ( 2 downto 0 );
    DDR_cas_n : inout STD_LOGIC;
    DDR_ck_n : inout STD_LOGIC;
    DDR_ck_p : inout STD_LOGIC;
    DDR_cke : inout STD_LOGIC;
    DDR_cs_n : inout STD_LOGIC;
    DDR_dm : inout STD_LOGIC_VECTOR ( 3 downto 0 );
    DDR_dq : inout STD_LOGIC_VECTOR ( 31 downto 0 );
    DDR_dqs_n : inout STD_LOGIC_VECTOR ( 3 downto 0 );
    DDR_dqs_p : inout STD_LOGIC_VECTOR ( 3 downto 0 );
    DDR_odt : inout STD_LOGIC;
    DDR_ras_n : inout STD_LOGIC;
    DDR_reset_n : inout STD_LOGIC;
    DDR_we_n : inout STD_LOGIC;
    FIXED_IO_ddr_vrn : inout STD_LOGIC;
    FIXED_IO_ddr_vrp : inout STD_LOGIC;
    FIXED_IO_mio : inout STD_LOGIC_VECTOR ( 53 downto 0 );
    FIXED_IO_ps_clk : inout STD_LOGIC;
    FIXED_IO_ps_porb : inout STD_LOGIC;
    FIXED_IO_ps_srstb : inout STD_LOGIC
  );
end ibert_top;

architecture STRUCTURE of ibert_top is

    -- IBERT start:
  component ibert_7series_gtx_0 is
  port (
    TXN_O : out STD_LOGIC_VECTOR((4*C_NUM_QUADS)-1 downto 0);
    TXP_O : out STD_LOGIC_VECTOR((4*C_NUM_QUADS)-1 downto 0);
    RXN_I : in STD_LOGIC_VECTOR((4*C_NUM_QUADS)-1 downto 0);
    RXP_I : in STD_LOGIC_VECTOR((4*C_NUM_QUADS)-1 downto 0);
    SYSCLK_I : in STD_LOGIC;
    GTREFCLK0_I : in STD_LOGIC_VECTOR(C_NUM_QUADS-1 downto 0);
    GTREFCLK1_I : in STD_LOGIC_VECTOR(C_NUM_QUADS-1 downto 0)
  );
  end component;
  
  signal sysclk_i : std_logic;
  signal mgt_ref_mon_i   : std_logic_vector(4-1 downto 0);
  signal gtrefclk0_i : std_logic_vector(C_NUM_QUADS-1    downto 0);
  signal gtrefclk1_i : std_logic_vector(C_NUM_QUADS-1    downto 0);
  signal refclk0_i   : std_logic_vector(2-1 downto 0);
  signal refclk1_i   : std_logic_vector(2-1 downto 0);
  
    -- IBERT finished:

  component zsys is
  port (
    DDR_cas_n : inout STD_LOGIC;
    DDR_cke : inout STD_LOGIC;
    DDR_ck_n : inout STD_LOGIC;
    DDR_ck_p : inout STD_LOGIC;
    DDR_cs_n : inout STD_LOGIC;
    DDR_reset_n : inout STD_LOGIC;
    DDR_odt : inout STD_LOGIC;
    DDR_ras_n : inout STD_LOGIC;
    DDR_we_n : inout STD_LOGIC;
    DDR_ba : inout STD_LOGIC_VECTOR ( 2 downto 0 );
    DDR_addr : inout STD_LOGIC_VECTOR ( 14 downto 0 );
    DDR_dm : inout STD_LOGIC_VECTOR ( 3 downto 0 );
    DDR_dq : inout STD_LOGIC_VECTOR ( 31 downto 0 );
    DDR_dqs_n : inout STD_LOGIC_VECTOR ( 3 downto 0 );
    DDR_dqs_p : inout STD_LOGIC_VECTOR ( 3 downto 0 );
    FIXED_IO_mio : inout STD_LOGIC_VECTOR ( 53 downto 0 );
    FIXED_IO_ddr_vrn : inout STD_LOGIC;
    FIXED_IO_ddr_vrp : inout STD_LOGIC;
    FIXED_IO_ps_srstb : inout STD_LOGIC;
    FIXED_IO_ps_clk : inout STD_LOGIC;
    FIXED_IO_ps_porb : inout STD_LOGIC;
    MGT_SYS_CLK_50 : out STD_LOGIC
  );
  end component zsys;
  component IOBUF is
  port (
    I : in STD_LOGIC;
    O : out STD_LOGIC;
    T : in STD_LOGIC;
    IO : inout STD_LOGIC
  );
 end component;
begin

zsys_i: component zsys
     port map (
      DDR_addr(14 downto 0) => DDR_addr(14 downto 0),
      DDR_ba(2 downto 0) => DDR_ba(2 downto 0),
      DDR_cas_n => DDR_cas_n,
      DDR_ck_n => DDR_ck_n,
      DDR_ck_p => DDR_ck_p,
      DDR_cke => DDR_cke,
      DDR_cs_n => DDR_cs_n,
      DDR_dm(3 downto 0) => DDR_dm(3 downto 0),
      DDR_dq(31 downto 0) => DDR_dq(31 downto 0),
      DDR_dqs_n(3 downto 0) => DDR_dqs_n(3 downto 0),
      DDR_dqs_p(3 downto 0) => DDR_dqs_p(3 downto 0),
      DDR_odt => DDR_odt,
      DDR_ras_n => DDR_ras_n,
      DDR_reset_n => DDR_reset_n,
      DDR_we_n => DDR_we_n,
      FIXED_IO_ddr_vrn => FIXED_IO_ddr_vrn,
      FIXED_IO_ddr_vrp => FIXED_IO_ddr_vrp,
      FIXED_IO_mio(53 downto 0) => FIXED_IO_mio(53 downto 0),
      FIXED_IO_ps_clk => FIXED_IO_ps_clk,
      FIXED_IO_ps_porb => FIXED_IO_ps_porb,
      FIXED_IO_ps_srstb => FIXED_IO_ps_srstb,
      MGT_SYS_CLK_50 => sysclk_i
    );
    -- IBERT start:
    u_ibert_core : ibert_7series_gtx_0
    port map
    (
      TXN_O       => TXN_O ,
      TXP_O       => TXP_O ,
      RXN_I       => RXN_I ,
      RXP_I       => RXP_I ,
      SYSCLK_I      => sysclk_i ,
      GTREFCLK0_I => gtrefclk0_i,
      GTREFCLK1_I => gtrefclk1_i
    );  
    
    u_buf_q2_clk0 : IBUFDS_GTE2
    port map 
    (
      O     => refclk0_i(0),
      ODIV2 => open,
      CEB   => '0',
      I     => GTREFCLK0P_I(0),
      IB    => GTREFCLK0N_I(0)
    );  
    u_buf_q2_clk1 : IBUFDS_GTE2
    port map 
    (
      O     => refclk1_i(0),
      ODIV2 => open,
      CEB   => '0',
      I     => GTREFCLK1P_I(0),
      IB    => GTREFCLK1N_I(0)
    );  

    -- u_buf_q3_clk0 : IBUFDS_GTE2
    -- port map 
    -- (
      -- O     => refclk0_i(1),
      -- ODIV2 => open,
      -- CEB   => '0',
      -- I     => GTREFCLK0P_I(1),
      -- IB    => GTREFCLK0N_I(1)
    -- );  
    -- u_buf_q3_clk1 : IBUFDS_GTE2
    -- port map 
    -- (
      -- O     => refclk1_i(1),
      -- ODIV2 => open,
      -- CEB   => '0',
      -- I     => GTREFCLK1P_I(1),
      -- IB    => GTREFCLK1N_I(1)
    -- );  

    gtrefclk0_i(0) <= refclk0_i(0);    
    gtrefclk1_i(0) <= refclk1_i(0);    
    -- gtrefclk0_i(1) <= refclk0_i(1);    
    -- gtrefclk1_i(1) <= refclk1_i(1);    
    refclk0_i(1) <= '0';    
    refclk1_i(1) <= '0';    
    
    -- IBERT finished:
end STRUCTURE;
